/*********************************************
 * vim:sw=8:ts=8:si:et
 * To use the above modeline in vim you must have "set modeline" in your .vimrc
 * Author: Evan Quirk
 * Copyright: GPL V2
 *
 *********************************************/
#include <avr/io.h>
#include "timeout.h"
#include "nixie.h"
#include "nixie_hw.h"
#define F_CPU 12500000UL  // 12.5 MHz
#ifndef ALIBC_OLD
#include <util/delay.h>
#else
#include <avr/delay.h>
#endif

void initnixie() {
NIXIE_DATA_DDR_A_L|= (1<<NIXIE_DATA_PIN_A_L);
NIXIE_DATA_DDR_B_L|= (1<<NIXIE_DATA_PIN_B_L);
NIXIE_DATA_DDR_C_L|= (1<<NIXIE_DATA_PIN_C_L);
NIXIE_DATA_DDR_D_L|= (1<<NIXIE_DATA_PIN_D_L);

NIXIE_DATA_DDR_A_R|= (1<<NIXIE_DATA_PIN_A_R);
NIXIE_DATA_DDR_B_R|= (1<<NIXIE_DATA_PIN_B_R);
NIXIE_DATA_DDR_C_R|= (1<<NIXIE_DATA_PIN_C_R);
NIXIE_DATA_DDR_D_R|= (1<<NIXIE_DATA_PIN_D_R);

NIXIE_ANODE_DDR_HH_ML|= (1<<NIXIE_ANODE_PIN_HH_ML);
NIXIE_ANODE_DDR_HL_SH|= (1<<NIXIE_ANODE_PIN_HL_SH);
NIXIE_ANODE_DDR_MH_SL|= (1<<NIXIE_ANODE_PIN_MH_SL);

}

void pushnixie(const uint8_t digitr, const uint8_t digitl, const uint8_t pinenable, uint8_t tms) {

// yay for horrible horrible coding :D
    switch(digitl) {
        
        case 1 :    NIXIE_DATA_PORT_D_L|= (1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L&=~(1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L&=~(1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L&=~(1<<NIXIE_DATA_PIN_A_L);
                    break;
                    
        case 2 :    NIXIE_DATA_PORT_D_L|= (1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L&=~(1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L&=~(1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L|= (1<<NIXIE_DATA_PIN_A_L);
                    break;

        case 3 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L&=~(1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L&=~(1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L&=~(1<<NIXIE_DATA_PIN_A_L);
                    break;

        case 4 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L&=~(1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L&=~(1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L|= (1<<NIXIE_DATA_PIN_A_L);
                    break;
                    
        case 5 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L|= (1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L&=~(1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L|= (1<<NIXIE_DATA_PIN_A_L);
                    break;

        case 6 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L|= (1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L&=~(1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L&=~(1<<NIXIE_DATA_PIN_A_L);
                    break;

        case 7 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L|= (1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L|= (1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L&=~(1<<NIXIE_DATA_PIN_A_L);
                    break;

        case 8 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L|= (1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L|= (1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L|= (1<<NIXIE_DATA_PIN_A_L);
                    break;

        case 9 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L&=~(1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L|= (1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L|= (1<<NIXIE_DATA_PIN_A_L);
                    break;

        case 0 :    NIXIE_DATA_PORT_D_L&=~(1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L&=~(1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L|= (1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L&=~(1<<NIXIE_DATA_PIN_A_L);
                    break;

        default :   NIXIE_DATA_PORT_D_L|= (1<<NIXIE_DATA_PIN_D_L);
                    NIXIE_DATA_PORT_C_L|= (1<<NIXIE_DATA_PIN_C_L);
                    NIXIE_DATA_PORT_B_L|= (1<<NIXIE_DATA_PIN_B_L);
                    NIXIE_DATA_PORT_A_L|= (1<<NIXIE_DATA_PIN_A_L);
                    break;

    } switch(digitr) {
        
        case 1 :    NIXIE_DATA_PORT_D_R|= (1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R&=~(1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R&=~(1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R&=~(1<<NIXIE_DATA_PIN_A_R);
                    break;
                    
        case 2 :    NIXIE_DATA_PORT_D_R|= (1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R&=~(1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R&=~(1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R|= (1<<NIXIE_DATA_PIN_A_R);
                    break;

        case 3 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R&=~(1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R&=~(1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R&=~(1<<NIXIE_DATA_PIN_A_R);
                    break;

        case 4 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R&=~(1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R&=~(1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R|= (1<<NIXIE_DATA_PIN_A_R);
                    break;
                    
        case 5 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R|= (1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R&=~(1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R|= (1<<NIXIE_DATA_PIN_A_R);
                    break;

        case 6 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R|= (1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R&=~(1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R&=~(1<<NIXIE_DATA_PIN_A_R);
                    break;

        case 7 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R|= (1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R|= (1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R&=~(1<<NIXIE_DATA_PIN_A_R);
                    break;

        case 8 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R|= (1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R|= (1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R|= (1<<NIXIE_DATA_PIN_A_R);
                    break;

        case 9 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R&=~(1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R|= (1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R|= (1<<NIXIE_DATA_PIN_A_R);
                    break;

        case 0 :    NIXIE_DATA_PORT_D_R&=~(1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R&=~(1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R|= (1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R&=~(1<<NIXIE_DATA_PIN_A_R);
                    break;

        default :   NIXIE_DATA_PORT_D_R|= (1<<NIXIE_DATA_PIN_D_R);
                    NIXIE_DATA_PORT_C_R|= (1<<NIXIE_DATA_PIN_C_R);
                    NIXIE_DATA_PORT_B_R|= (1<<NIXIE_DATA_PIN_B_R);
                    NIXIE_DATA_PORT_A_R|= (1<<NIXIE_DATA_PIN_A_R);
                    break;

    }
        NIXIE_ANODE_PORT|= (1<<pinenable);
        while(tms){
                _delay_ms(0.10);
                tms--;
        }
        NIXIE_ANODE_PORT&=~(1<<pinenable);
}
