/*************************************************************************
 Title	:   C include file for the HW defs for driving BCD output to nixies
 Author:    Evan Quirk
***************************************************************************/
#ifndef NIXIE_HW_H
#define NIXIE_HW_H

/* change these definitions according to your hardware */

#define NIXIE_DATA_PIN_A_L  PD4	// pin for Nixie left data line A
#define NIXIE_DATA_PORT_A_L  PORTD	// port for Nixie left data line A
#define NIXIE_DATA_DDR_A_L  DDRD	// ddr for Nixie left data line A

#define NIXIE_DATA_PIN_D_L  PD3	// pin for Nixie left data line D
#define NIXIE_DATA_PORT_D_L  PORTD	// port for Nixie left data line D
#define NIXIE_DATA_DDR_D_L  DDRD	// ddr for Nixie left data line D

#define NIXIE_DATA_PIN_B_L  PD1	// pin for Nixie left data line B
#define NIXIE_DATA_PORT_B_L  PORTD	// port for Nixie left data line B
#define NIXIE_DATA_DDR_B_L  DDRD	// ddr for Nixie left data line B

#define NIXIE_DATA_PIN_C_L  PD0	// pin for Nixie left data line C
#define NIXIE_DATA_PORT_C_L  PORTD	// port for Nixie left data line C
#define NIXIE_DATA_DDR_C_L  DDRD	// ddr for Nixie left data line C

#define NIXIE_DATA_PIN_A_R  PD7	// pin for Nixie right data line A
#define NIXIE_DATA_PORT_A_R  PORTD	// port for Nixie right data line A
#define NIXIE_DATA_DDR_A_R  DDRD	// ddr for Nixie right data line A

#define NIXIE_DATA_PIN_D_R  PD6	// pin for Nixie right data line D
#define NIXIE_DATA_PORT_D_R  PORTD	// port for Nixie right data line D
#define NIXIE_DATA_DDR_D_R  DDRD	// ddr for Nixie right data line D

#define NIXIE_DATA_PIN_B_R  PD5	// pin for Nixie right data line B
#define NIXIE_DATA_PORT_B_R  PORTD	// port for Nixie right data line B
#define NIXIE_DATA_DDR_B_R  DDRD	// ddr for Nixie right data line B

#define NIXIE_DATA_PIN_C_R  PB7	// pin for Nixie right data line C
#define NIXIE_DATA_PORT_C_R  PORTB	// port for Nixie right data line C
#define NIXIE_DATA_DDR_C_R  DDRB	// ddr for Nixie right data line C


#define NIXIE_ANODE_PIN_HH_ML       PC2  // pin for Nixie anode line HH and ML
#define NIXIE_ANODE_DDR_HH_ML       DDRC	// ddr for Nixie anode line HH and ML

#define NIXIE_ANODE_PIN_HL_SH       PC1  // pin for Nixie anode line HL and SH
#define NIXIE_ANODE_DDR_HL_SH       DDRC	// ddr for Nixie anode line HL and SH

#define NIXIE_ANODE_PIN_MH_SL       PC0  // pin for Nixie anode line MH and SL
#define NIXIE_ANODE_DDR_MH_SL       DDRC	// ddr for Nixie anode line MH and SL

#define NIXIE_ANODE_PORT       PORTC  // port for Nixie anodes



#endif //NIXIE_HW_H

